#include<stdio.h>
#include<math.h>
int main()
{
 int i,j,p,k,s,sqr,del[1001],ind=0,br=0,sum=0,p1;

 scanf("%d %d",&p,&k);

 for(s=1;s<=k;s++)
  {  sqr=sqrt(p); ind=0;  br=0; p1=p;
   if(p==1) { p=0; break; }
   for(i=2;i<=sqr;i++)
	{
	 while(p1%i==0) { del[ind]=i; ind++; p1=p1/i; br++;}
	}
   if(br==0) { p=1; }
   else {
   sum=0;
   for(i=0;i<br;i++)
	{
	 sum=sum+p/del[i];
	}
	p=sum;
   }

  }

 printf("%d",p);

return 0;
}